{SINE/COSINE DEMO PROGREM}
PROGRAM SINE(INPUT,OUTPUT);
USES(MATH);
USES(AUDVID);
CONST PC=10;
    AR=11;
    XR=12;
    YR=13;
	PETSCII=143;	{SWITCH TO PETSCII}
	ISO=15;			{SWITCH TO ISO TEXT}
	CLS=147;		{CLEAR TEXT SCREEN}
    PLT=-16;
    GFX=-224;
    GCS=-221;
    GCL=-215;
    CIR=-203;
    RCT=-209;
    LIN=-212;
    SPX=-245;
    PXY=-257;
	SCR=-161;		{$FF5F KERNAL SCREEN MODE}
    STI=-37;
    RTI=-34;
	PCR=-191;		{$FF41 KERNAL GRAPH_PUT_CHAR}
	SCREEN=$B000;	{$B000 VRAM ADDRESS OF TEXT SCREEN}
	
VAR I,A,B,L,Z,Z1,C,D,S,TI,SEC,JIF,X1,Y1: INTEGER;
X: ARRAY [0..31] OF INTEGER;
Y: ARRAY [0..31] OF INTEGER;
TXTCOL: ARRAY [0..15] OF INTEGER;
TEST: ARRAY [0..4] OF INTEGER;
CH: CHAR;
STR,STR2: ARRAY [0..30] OF CHAR;

PROCEDURE PAUSE(JIFFIES: INTEGER);
	BEGIN
		REGS[AR]:=JIFFIES;
		WAIT();
	END;

PROCEDURE FMNOTE(CHANNEL,NOTE: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=$C003;		{can't load this directly!}
		REGS[0]:=ADDR;		{$C003 BASIC FMNOTE LO BYTE}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=NOTE;
		REGS[PC]:=0;		{CARRY MUST BE CLEAR}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;

PROCEDURE INSTRUMENT(CHANNEL,PATCH: INTEGER);
VAR ADDR: INTEGER;
	BEGIN
		ADDR:=$C069;		
		REGS[0]:=ADDR;		{$C069 LOAD PATCH(INSTRUMENT)}
		REGS[AR]:=CHANNEL;
		REGS[XR]:=PATCH;
		REGS[PC]:=1;		{CARRY MUST BE SET}
		AUDIO();			{ACCESS BASIC AUDIO ROUTINE}
	END;

PROCEDURE SCRNMODE(MODE:INTEGER);
	BEGIN
		REGS[AR]:=MODE;
		CALL(SCR);
	END;

PROCEDURE GCOLORS(FG,BG,FILL: INTEGER);
    BEGIN
        REGS[AR]:=FG;
        REGS[YR]:=BG;
        REGS[XR]:=FILL;
        CALL(GCL);
    END;

PROCEDURE PLOT(COLUMN,ROW: INTEGER);
    BEGIN
        REGS[PC]:=0;
        REGS[XR]:=ROW;
        REGS[YR]:=COLUMN;
        CALL(PLT);
    END;

PROCEDURE PUTCHAR(X,Y,C: INTEGER);
	BEGIN
		REGS[0]:=X;
		REGS[1]:=Y;
		REGS[AR]:=C;
		CALL(PCR);
	END;

PROCEDURE GRAPHICS;
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;
    

PROCEDURE SETPIXEL(X1,Y1,C: INTEGER);
    BEGIN
        REGS[0]:=X1;
        REGS[1]:=Y1;
        CALL(PXY);
        REGS[AR]:=C;
        CALL(SPX);
    END;  
	
PROCEDURE RECT(X,Y,W,H,FILL: INTEGER);	{draw rectangle}
    BEGIN
        REGS[PC]:=FILL;
        REGS[0]:=X;REGS[1]:=Y;REGS[2]:=W;REGS[3]:=H;REGS[4]:=0;
        CALL(RCT);
    END;	

PROCEDURE BELL;
	BEGIN
		CH:=CHR(7);		{BELL SOUND}
		WRITE(CH);	
	END;
	
PROCEDURE GCLEAR;					{clear graphics screen}
    BEGIN
        CALL(GCS);
    END;	

        
BEGIN
	SCRNMODE(3);
	READ(TXTCOL[0],'144,5,28,159,156,30,31,158,129,149,150,151,152,153,154,155');
	CH:=CHR(TXTCOL[10]);	{TEXT COLOR PEACH OR IS IT SALMON?}
	WRITE(CH);
    PLOT(0,5);
    WRITELN('Press enter to start.');
	READ(STR[0],'This is a string on the waves.');
	READ(STR2[0],'Or the waves between strings. ');
    READ(I);
	INSTRUMENT(1,99);
	FMNOTE(1,44);
	{PAUSE(160);}
	{FMNOTE(1,0);}
	CH:=CHR(147);
	WRITE(CH);		{CLEAR SCREEN}
	I:=STR[0];
    GRAPHICS;
	GCOLORS(0,3,3);
	GCLEAR;
	A:=5;			{AMPLITUDE}
	B:=4;			{WAVELENGTH}
	L:=0;
	C:=1;
	GCOLORS(6,6,6);
	RECT(0,126,320,114,TRUE);
	WHILE L < 320 DO BEGIN		{SINE CURVE}
		S:=SIN(A*L+B);
		Y1:=120+(S * A) DIV 255;
		Z:= L MOD 7;			{do this}
		IF L < 7*I THEN BEGIN
			IF Z = 0 THEN BEGIN		{instead of 'if x mod 7 = 0'}
				X[C-1]:=L;
				Y[C-1]:=Y1;
				C:=C+1;
			END;
		END;
		SETPIXEL(L,Y1,0);
		Z1:=Y1;
		WHILE Z1 < 126 DO BEGIN
			SETPIXEL(L,Z1,6);
			Z1:=Z1+1;
		END;
		L:=L+1;					
	END;	
	C:=0;
		GCOLORS(5,7,7);
	WHILE C < I DO BEGIN
		D:=ORD(STR[C+1]);	
		X1:=X[C];
		Y1:=Y[C];
		PUTCHAR(X1+70,Y1-20,D);
		C:=C+1;					
	END;	
	C:=0;
	GCOLORS(2,7,7);
	WHILE C < I DO BEGIN
		D:=ORD(STR2[C+1]);	
		X1:=X[C];
		Y1:=Y[C];
		PUTCHAR(X1+70,Y1+20,D);
		C:=C+1;					
	END;	
	A:=0;
	B:=10;
	WHILE A <= 90 DO BEGIN			{MAKE A DISC}
		S:=SIN(A);
		C:=COS(A);
		X1:=(B*S) DIV 255;
		Y1:=(B*C) DIV 255;
		SETPIXEL(240+X1,40-Y1,7);
		SETPIXEL(240-X1,40-Y1,7);
		SETPIXEL(240+X1,40+Y1,7);
		SETPIXEL(240-X1,40+Y1,7);
		SETPIXEL(240+B-1,40,7);
		SETPIXEL(240-B+1,40,7);
		Z:=240;
		WHILE Z < 240+X1 DO BEGIN
			SETPIXEL(Z,40-Y1,7);
			SETPIXEL(Z,40+Y1,7);
			Z:=Z+1;
		END;
		Z:=240;
		WHILE Z > 240-X1 DO BEGIN
			SETPIXEL(Z,40-Y1,7);
			SETPIXEL(Z,40+Y1,7);
			Z:=Z-1;
		END;		
		Z:=230;
		WHILE Z < 251 DO BEGIN
			SETPIXEL(Z,40,7);
			Z:=Z+1;
		END;
		A:=A+7;
	END;
	INSTRUMENT(1,122);
	PLOT(0,0);
	WRITELN(CH,'Who needs real numbers anyway?');
	WRITE('Press enter to exit program.'); 
	FMNOTE(1,38);
	READ(CH);
 END.
